Index: /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3683)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/callcorrk.F90	(revision 3684)
@@ -32,5 +32,5 @@
       use comcstfi_mod, only: pi, mugaz, cpp, r, g
       use callkeys_mod, only: diurnal,tracer,varfixed, &
-                              diagdtau,kastprof,strictboundcorrk,specOLR, &
+                              kastprof,strictboundcorrk,specOLR, &
                               tplanckmin,tplanckmax,global1d, &
                               optichaze,haze_radproffix,&
@@ -1061,23 +1061,20 @@
          end do
 
-      !  Optical thickness diagnostics (added by JVO)
-      if (diagdtau) then
-        do l=1,L_NLAYRAD
-          do nw=1,L_NSPECTV
-            int_dtauv(ig,l,nw) = 0.0d0
-             DO k=1,L_NGAUSS
-              ! Output exp(-tau) because gweight ponderates exp and not tau itself
-              int_dtauv(ig,l,nw)= int_dtauv(ig,l,nw) + exp(-dtauv(l,nw,k))*gweight(k)
-             ENDDO
-          enddo
-          do nw=1,L_NSPECTI
-           int_dtaui(ig,l,nw) = 0.0d0
-             DO k=1,L_NGAUSS
-              ! Output exp(-tau) because gweight ponderates exp and not tau itself
-              int_dtaui(ig,l,nw)= int_dtaui(ig,l,nw) + exp(-dtaui(l,nw,k))*gweight(k)
-             ENDDO
-          enddo
-        enddo
-      endif
+         ! Optical thickness diagnostics
+         ! Output exp(-tau) because gweight ponderates exp and not tau itself
+         int_dtauv(ig,:,:) = 0.0d0
+         int_dtaui(ig,:,:) = 0.0d0
+         do l=1,L_NLAYRAD
+            do nw=1,L_NSPECTV
+               do k=1,L_NGAUSS
+                  int_dtauv(ig,l,nw)= int_dtauv(ig,l,nw) + exp(-dtauv(l,nw,k))*gweight(k)
+               enddo
+            enddo
+            do nw=1,L_NSPECTI
+               do k=1,L_NGAUSS
+                  int_dtaui(ig,l,nw)= int_dtaui(ig,l,nw) + exp(-dtaui(l,nw,k))*gweight(k)
+               enddo
+            enddo
+         enddo
 
 ! **********************************************************
Index: /trunk/LMDZ.PLUTO/libf/phypluto/callkeys_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/callkeys_mod.F90	(revision 3683)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/callkeys_mod.F90	(revision 3684)
@@ -22,6 +22,5 @@
       logical,save :: specOLR
       logical,save :: kastprof
-      logical,save :: diagdtau
-!$OMP THREADPRIVATE(enertest,nonideal,meanOLR,kastprof,diagdtau)
+!$OMP THREADPRIVATE(enertest,nonideal,meanOLR,kastprof)
       logical,save :: newtonian
       logical,save :: force_cpp
Index: /trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90	(revision 3683)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/inifis_mod.F90	(revision 3684)
@@ -375,10 +375,4 @@
      if (is_master) write(*,*)trim(rname)//": specOLR = ",specOLR
 
-     if (is_master) write(*,*)trim(rname)//&
-       ": Output diagnostic optical thickness attenuation exp(-tau)?"
-     diagdtau=.false.
-     call getin_p("diagdtau",diagdtau)
-     if (is_master) write(*,*)trim(rname)//": diagdtau = ",diagdtau
-
      if (is_master) write(*,*)trim(rname)//": Operate in kastprof mode?"
      kastprof=.false.
Index: /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3683)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3684)
@@ -48,5 +48,5 @@
                               callrad, callsoil, nosurf,                      &
                               callconduct,callmolvis,callmoldiff,             &
-                              corrk, diagdtau,                                &
+                              corrk,                                          &
                               diurnal, enertest, fat1au,                      &
                               icetstep, intheat, iradia, kastprof,            &
@@ -2190,16 +2190,14 @@
 
       ! Diagnostics of optical thickness
-      ! Warning this is exp(-tau), I let you postproc with -log to have tau itself - JVO 19
-      if (diagdtau.and..not.oldplutocorrk) then
-            do nw=1,L_NSPECTV
-               write(str2,'(i2.2)') nw
-               call write_output('dtauv'//str2,'Layer optical thickness attenuation in VI band '//str2,'',int_dtauv(:,nlayer:1:-1,nw))
-            enddo
-            do nw=1,L_NSPECTI
-               write(str2,'(i2.2)') nw
-               call write_output('dtaui'//str2,'Layer optical thickness attenuation in IR band '//str2,'',int_dtaui(:,nlayer:1:-1,nw))
-            enddo
-      endif
-
+      ! Warning this is exp(-tau), I let you postproc with -log to have tau itself
+      !do nw=1,L_NSPECTV
+      !   write(str2,'(i2.2)') nw
+      !   call write_output('dtauv'//str2,'Layer optical thickness attenuation in VI band '//str2,'',int_dtauv(:,nlayer:1:-1,nw))
+      !enddo
+      !do nw=1,L_NSPECTI
+      !   write(str2,'(i2.2)') nw
+      !   call write_output('dtaui'//str2,'Layer optical thickness attenuation in IR band '//str2,'',int_dtaui(:,nlayer:1:-1,nw))
+      !enddo
+      
       ! Temporary inclusions for heating diagnostics.
       if (.not.fast) then