Index: trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 3370)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 3701)
@@ -783,5 +783,5 @@
 use tracer_h, only: nesp
 use chimiedata_h
-use callkeys_mod, only: jonline
+use callkeys_mod, only: jonline, reactfile
 
 implicit none
@@ -797,5 +797,4 @@
 integer :: iq, ireact
 
-character(len = 128)              :: reactfile       ! reactions table file name
 integer                           :: nbq             ! number of species in reactions file
 integer                           :: nlines          ! number of lines in reactions file
@@ -828,10 +827,5 @@
 qnreact        = 0
 
-write(*,*) "Read reaction file"
-reactfile = "reactfile" ! default
-call getin_p("reactfile",reactfile) ! default path
-write(*,*) " reactfile = ",trim(reactfile)
-
-call count_react(reactfile,nlines,nreact,nb_phot,nb_reaction_4,nb_reaction_3,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+call count_react(nlines,nreact,nb_phot,nb_reaction_4,nb_reaction_3,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
 
 !!!!!!!!!!! Hard coding reaction !!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -885,5 +879,5 @@
 jparamline(:)   = ''
 
-call get_react(reactfile,nlines,nreact,specheck,specheckr,specheckp,nbq,nb_phot,nb_reaction_4,nb_reaction_3)
+call get_react(nlines,nreact,specheck,specheckr,specheckp,nbq,nb_phot,nb_reaction_4,nb_reaction_3)
 
 ! rewrite jlabel corretly for output
@@ -1161,5 +1155,5 @@
 !*****************************************************************
 
-    subroutine count_react(reactfile,nlines,nreact,nb_phot,nb_reaction_4,nb_reaction_3,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+    subroutine count_react(nlines,nreact,nb_phot,nb_reaction_4,nb_reaction_3,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
 
 !*****************************************************************
@@ -1168,5 +1162,4 @@
 
         implicit none
-        character(*), intent(in)     :: reactfile     ! name of the file to read 
         integer,      intent(inout)  :: nlines        ! number of lines in the file
         integer,      intent(out)    :: nreact        ! real number of reaction
@@ -1193,13 +1186,10 @@
 
         open(402, form = 'formatted', status = 'old',                &
-              file ='chemnetwork/'//trim(reactfile),iostat=ierr)
+              file =trim(reactfile),iostat=ierr)
 
         if (ierr /= 0) THEN
-           write(*,*)'Error : cannot open chemical reaction file : chemnetwork/'//trim(reactfile)
-           write(*,*)'It should be in your simulation directory in chemnetwork directory'
-           write(*,*)'   You can change the input chemical reactions file name in'
-           write(*,*)'   callphys.def with:'
-           write(*,*)'   monoreact=filename or bimolreact=filename or quadrareact=filename'
-           write(*,*)'   depending on what chemical reaction type it is'
+           write(*,*)'Error : cannot open chemical reaction file : '//trim(reactfile)
+           write(*,*)'28/03/2025: New default value is network.def (in simulation folder)'
+           write(*,*)'Former default is chemnetwork/reactfile'
            call abort
         end if
@@ -1257,5 +1247,5 @@
             else
               print*, 'Error in indice: wrong index coefficient rate line ',nlines
-              print*, 'in file : chemnetwork/'//trim(reactfile)
+              print*, 'in file : '//trim(reactfile)
               print*, 'It should be 0 for photolysis reations and 1 or 2 for the others'
               print*, 'And not : ', typerate
@@ -1273,5 +1263,5 @@
 !*****************************************************************
 
-    subroutine get_react(reactfile,nlines,nreact,specheck,specheckr,specheckp, &
+    subroutine get_react(nlines,nreact,specheck,specheckr,specheckp, &
                          nbq,nb_phot,nb_reaction_4,nb_reaction_3)
 
@@ -1284,5 +1274,4 @@
 
         implicit none
-        character(*), intent(in)     :: reactfile          ! name of the file to read 
         integer,      intent(in)     :: nlines             ! number of lines in the file
         integer,      intent(in)     :: nreact             ! real number of reaction in the file
@@ -1319,13 +1308,10 @@
 
         open(402, form = 'formatted', status = 'old',                &
-              file ='chemnetwork/'//trim(reactfile),iostat=ierr)
+              file =trim(reactfile),iostat=ierr)
 
         if (ierr /= 0) THEN
-           write(*,*)'Error : cannot open chemical reaction file : chemnetwork/'//trim(reactfile)
-           write(*,*)'It should be in your simulation directory in chemnetwork directory'
-           write(*,*)'   You can change the input chemical reactions file name in'
-           write(*,*)'   callphys.def with:'
-           write(*,*)'   monoreact=filename or bimolreact=filename or quadrareact=filename'
-           write(*,*)'   depending on what chemical reaction type it is'
+           write(*,*)'Error : cannot open chemical reaction file : '//trim(reactfile)
+           write(*,*)'28/03/2025: New default value is network.def (in simulation folder)'
+           write(*,*)'Former default is chemnetwork/reactfile'
            call abort
         end if