Index: trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3770)
+++ trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 3778)
@@ -9,5 +9,5 @@
 SUBROUTINE pemetat0(filename,ngrid,nsoil_PCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,icetable_depth,icetable_thickness,ice_porefilling, &
                     tsurf_avg_yr1,tsurf_avg_yr2,q_co2,q_h2o,ps_timeseries,ps_avg_global,d_h2oice,d_co2ice,co2_ice,h2o_ice,                         &
-                    watersurf_avg,watersoil_avg,m_co2_regolith_phys,deltam_co2_regolith_phys,m_h2o_regolith_phys,deltam_h2o_regolith_phys,stratif)
+                    watersurf_avg,watersoil_avg,m_co2_regolith_phys,deltam_co2_regolith_phys,m_h2o_regolith_phys,deltam_h2o_regolith_phys,layerings_map)
 
 use iostart_PEM,                only: open_startphy, close_startphy, get_field, get_var, inquire_dimension, inquire_dimension_length
@@ -54,5 +54,5 @@
 real, dimension(ngrid,nslope),           intent(out) :: h2o_ice                  ! h2o ice amount [kg/m^2]
 real, dimension(ngrid,nslope),           intent(out) :: co2_ice                  ! co2 ice amount [kg/m^2]
-type(layering), dimension(ngrid,nslope), intent(inout) :: stratif             ! stratification (layerings)
+type(layering), dimension(ngrid,nslope), intent(inout) :: layerings_map             ! Layerings
 real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: TI_PEM              ! soil (mid-layer) thermal inertia in the PEM grid [SI]
 real, dimension(ngrid,nsoil_PEM,nslope), intent(inout) :: tsoil_PEM           ! soil (mid-layer) temperature [K]
@@ -71,5 +71,5 @@
 character(2)                            :: num               ! intermediate string to read PEM start sloped variables
 logical                                 :: startpem_file     ! boolean to check if we read the startfile or not
-real, dimension(:,:,:,:), allocatable   :: stratif_array     ! Array for stratification (layerings)
+real, dimension(:,:,:,:), allocatable   :: stratif_array     ! Array for layerings
 
 #ifdef CPP_STD
@@ -132,5 +132,5 @@
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    ! Stratification (layerings)
+    ! Layerings
     nb_str_max = 68
     if (layering_algo) then
@@ -178,21 +178,21 @@
         enddo ! islope
         if (.not. found) then
-            write(*,*) 'So the deposits are initialized with sub-surface strata.'
+            write(*,*) 'So the layerings are initialized with sub-surface strata.'
             write(*,*) 'Ice is added with ''ini_huge_h2oice'' where ''watercaptag'' is true and otherwise with ''perennial_co2ice'' found in the PCM.'
             do ig = 1,ngrid
                 if (watercaptag(ig)) then
                     do islope = 1,nslope
-                        call ini_layering(stratif(ig,islope))
-                        call add_stratum(stratif(ig,islope),ini_huge_h2oice,0.,ini_huge_h2oice,0.,0.,0.)
+                        call ini_layering(layerings_map(ig,islope))
+                        call add_stratum(layerings_map(ig,islope),ini_huge_h2oice,0.,ini_huge_h2oice,0.,0.,0.)
                     enddo
                 else
                     do islope = 1,nslope
-                        call ini_layering(stratif(ig,islope))
-                        if (perennial_co2ice(ig,islope) > 0.) call add_stratum(stratif(ig,islope),perennial_co2ice(ig,islope),perennial_co2ice(ig,islope),0.,0.,0.,0.)
+                        call ini_layering(layerings_map(ig,islope))
+                        if (perennial_co2ice(ig,islope) > 0.) call add_stratum(layerings_map(ig,islope),perennial_co2ice(ig,islope),perennial_co2ice(ig,islope),0.,0.,0.,0.)
                     enddo
                 endif
             enddo
         else
-            call array2stratif(stratif_array,ngrid,nslope,stratif)
+            call array2stratif(stratif_array,ngrid,nslope,layerings_map)
         endif
         deallocate(stratif_array)
@@ -383,19 +383,19 @@
     co2_ice = perennial_co2ice
 
-    ! Stratification (layerings)
+    ! Layerings
     nb_str_max = 68
     if (layering_algo) then
-        write(*,*)'So the deposits are initialized with sub-surface strata.'
+        write(*,*)'So the layerings are initialized with sub-surface strata.'
         write(*,*)'Ice is added with ''ini_huge_h2oice'' where ''watercaptag'' is true and otherwise with ''perennial_co2ice'' found in the PCM.'
         do ig = 1,ngrid
             if (watercaptag(ig)) then
                 do islope = 1,nslope
-                    call ini_layering(stratif(ig,islope))
-                    call add_stratum(stratif(ig,islope),ini_huge_h2oice,0.,ini_huge_h2oice,0.,0.,0.)
+                    call ini_layering(layerings_map(ig,islope))
+                    call add_stratum(layerings_map(ig,islope),ini_huge_h2oice,0.,ini_huge_h2oice,0.,0.,0.)
                 enddo
             else
                 do islope = 1,nslope
-                    call ini_layering(stratif(ig,islope))
-                    if (perennial_co2ice(ig,islope) > 0.) call add_stratum(stratif(ig,islope),perennial_co2ice(ig,islope),perennial_co2ice(ig,islope),0.,0.,0.,0.)
+                    call ini_layering(layerings_map(ig,islope))
+                    if (perennial_co2ice(ig,islope) > 0.) call add_stratum(layerings_map(ig,islope),perennial_co2ice(ig,islope),perennial_co2ice(ig,islope),0.,0.,0.,0.)
                 enddo
             endif